;;=================================================================================================================================
;; gdm_m1_gewindebolzen.lsp
;; erstellt: os / 18.03.2004
;; geaendert: os / 17.09.2004 - metr. Feingewinde hinzu
;; geaendert: os / 04.07.2008 14:57 - Auswahl ueber Tabelle ; Gewinderichtung ueber Flaeche -> Richtung Umkehren entfernt
;;=================================================================================================================================

(in-package  :GDM)
(use-package :OLI)

;; Logical Table fuer metrisches Gewinde
(sd-create-logical-table "GDM-Gewinde-aussen-Tab"
  :columns     '(:GEW_NAME      :NENN_D    :KERN_D_BOLZEN  :STEIGUNG    :GEW_ART  :GEW_TYPE    :GEW_UNIT)
  :columnNames (sd-multi-lang-string
               '("Thread Name"  "Nominal D." "Core D."       "Pitch"      "Type"    "Thread Type" "Thread Unit")
               :german
               '("Gew. Name"    "Nenn D."    "Kern D."       "Steigung"   "Art"     "Gew. Typ"   "Gew. Einheit")
               );;sd-multi-lang-string
  :types       '(:string        :length    :length         :length      nil       nil          nil)
  :units       '(nil            :mm        :mm             :mm          nil       nil          nil)
  :contents   '(
                ("M1"            1.0       0.73            0.25        :M         :OUTER       :METRIC)
                ("M1,2"          1.2       0.93            0.25        :M         :OUTER       :METRIC)
                ("M1,6"          1.6       1.22            0.35        :M         :OUTER       :METRIC)
                ("M2"            2.0       1.57            0.40        :M         :OUTER       :METRIC)
                ("M2,5"          2.5       2.01            0.35        :M         :OUTER       :METRIC)
                ("M3"            3.0       2.46            0.50        :M         :OUTER       :METRIC)
                ("M4"            4.0       3.24            0.70        :M         :OUTER       :METRIC)
                ("M5"            5.0       4.13            0.80        :M         :OUTER       :METRIC)
                ("M6"            6.0       4.92            1.00        :M         :OUTER       :METRIC)
                ("M8"            8.0       6.65            1.25        :M         :OUTER       :METRIC)
                ("M10"          10.0       8.38            1.50        :M         :OUTER       :METRIC)
                ("M12"          12.0      10.11            1.75        :M         :OUTER       :METRIC)
                ("M16"          16.0      13.84            2.00        :M         :OUTER       :METRIC)
                ("M20"          20.0      17.29            2.50        :M         :OUTER       :METRIC)
                ("M24"          24.0      20.75            3.00        :M         :OUTER       :METRIC)
                ("M30"          30.0      26.21            3.50        :M         :OUTER       :METRIC)
                ("M36"          36.0      31.67            4.00        :M         :OUTER       :METRIC)
                ("M42"          42.0      37.13            4.50        :M         :OUTER       :METRIC)
                ("M48"          48.0      42.59            5.00        :M         :OUTER       :METRIC)
                ("M56"          56.0      50.05            5.50        :M         :OUTER       :METRIC)
                ("M64"          64.0      57.51            6.00        :M         :OUTER       :METRIC)
                ("M2x0,25"       2.0       1.69            0.25        :MF        :OUTER       :METRIC)
                ("M3x0,25"       3.0       2.69            0.25        :MF        :OUTER       :METRIC)
                ("M4x0,2"        4.0       3.76            0.20        :MF        :OUTER       :METRIC)
                ("M4x0,35"       4.0       3.57            0.35        :MF        :OUTER       :METRIC)
                ("M5x0,25"       5.0       4.69            0.25        :MF        :OUTER       :METRIC)
                ("M5x0,5"        5.0       4.39            0.50        :MF        :OUTER       :METRIC)
                ("M6x0,25"       6.0       5.69            0.25        :MF        :OUTER       :METRIC)
                ("MM6x0,5"       6.0       5.39            0.50        :MF        :OUTER       :METRIC)
                ("M6x0,75"       6.0       5.08            0.75        :MF        :OUTER       :METRIC)
                ("M8x0,25"       8.0       7.69            0.25        :MF        :OUTER       :METRIC)
                ("M8x0,5"        8.0       7.39            0.50        :MF        :OUTER       :METRIC)
                ("M8x1"          8.0       6.77            1.00        :MF        :OUTER       :METRIC)
                ("M10x0,25"     10.0       9.69            0.25        :MF        :OUTER       :METRIC)
                ("M10x0,5"      10.0       9.39            0.50        :MF        :OUTER       :METRIC)
                ("M10x1"        10.0       8.77            1.00        :MF        :OUTER       :METRIC)
                ("M12x0,35"     12.0      11.57            0.35        :MF        :OUTER       :METRIC)
                ("M12x0,5"      12.0      11.39            0.50        :MF        :OUTER       :METRIC)
                ("M12x1"        12.0      10.77            1.00        :MF        :OUTER       :METRIC)
                ("M16x0,5"      16.0      15.39            0.50        :MF        :OUTER       :METRIC)
                ("M16x1"        16.0      14.77            1.00        :MF        :OUTER       :METRIC)
                ("M16x1,5"      16.0      14.16            1.50        :MF        :OUTER       :METRIC)
                ("M20x1"        20.0      18.77            1.00        :MF        :OUTER       :METRIC)
                ("M20x1,5"      20.0      18.16            1.50        :MF        :OUTER       :METRIC)
                ("M24x1,5"      24.0      22.16            1.50        :MF        :OUTER       :METRIC)
                ("M24x2"        24.0      21.55            2.00        :MF        :OUTER       :METRIC)
                ("M30x1,5"      30.0      28.16            1.50        :MF        :OUTER       :METRIC)
                ("M30x2"        30.0      27.55            2.00        :MF        :OUTER       :METRIC)
                ("M36x1,5"      36.0      34.16            1.50        :MF        :OUTER       :METRIC)
                ("M36x2"        36.0      33.55            2.00        :MF        :OUTER       :METRIC)
                ("M42x1,5"      42.0      40.16            1.50        :MF        :OUTER       :METRIC)
                ("M42x2"        42.0      39.55            2.00        :MF        :OUTER       :METRIC)
                ("M48x1,5"      48.0      46.16            1.50        :MF        :OUTER       :METRIC)
                ("M48x2"        48.0      45.55            2.00        :MF        :OUTER       :METRIC)
                ("M56x1,5"      56.0      54.16            1.50        :MF        :OUTER       :METRIC)
                ("M56x2"        56.0      53.55            2.00        :MF        :OUTER       :METRIC)
                ("M64x2"        64.0      61.55            2.00        :MF        :OUTER       :METRIC)
               )
);;sd-create-logical-table

;; =====================
(sd-create-display-table
     "GDM-Gewinde-aussen-Tab"
     :tableTitle         "Metrische Gewinde"
     :logicalTable       "GDM-Gewinde-aussen-Tab"
     :columns            '(:GEW_NAME :NENN_D :KERN_D_BOLZEN :STEIGUNG :GEW_ART :GEW_TYPE :GEW_UNIT)
     :applyColumns       '(:GEW_NAME :NENN_D :KERN_D_BOLZEN :STEIGUNG :GEW_ART :GEW_TYPE :GEW_UNIT)
     :displayHeight      350
     :filterStatusLine   nil
     :selectionMode      :single-row
     :applyAction        :default-tokens
);;sd-create-display-table


(sd-defdialog 'gdm-m1-gewindebolzen-dialog
  :dialog-title (sd-multi-lang-string "Thread Stud" :german "Gewindebolzen")
  :toolbox-button t
  :variables '(

   (FLAECHE)
   (ALLES)
   (RADIUS)
   (RICHTUNG)
   (ACHSEN-FEEDBACK)
   (K_ALLES)
   (K_MITTELPUNKT)
   (K_RADIUS)
   (K_V-RICHTUNG)
   (K_ACHSEN-R)
   (K_DURCHMESSER)
   (PUNKT_3D)
   (F_ACHSEN-R)

   (TEIL
     :value-type :part-incl-new
     :modifies :contents
     :title (sd-multi-lang-string "Part" :german "Teil")
     :prompt-text (sd-multi-lang-string "Specify Part." :german "Teil angeben."))

   (AKT_WP
     :value-type :wp
     :title (sd-multi-lang-string "Workplane" :german "AEbene")
     :initial-enable nil
     :prompt-text (sd-multi-lang-string "Specify Workplane." :german "Arbeitsebene angeben."))

   (DUMMY_TITLE_2 :title (sd-multi-lang-string "Thread" :german "Gewinde"))
   (GEW_NAME
     :title (sd-multi-lang-string "Thread Name" :german "Gew. Name")
     :value-type :string
     :show-input-tool (sd-show-display-table "GDM-Gewinde-aussen-Tab" :position '("TOP-MENU-TOOLBOX-TB" :lefttop 70 50))
     :hide-input-tool (sd-hide-display-table "GDM-Gewinde-aussen-Tab" :ignorePin t))
#|
   (PUSH-SHOW
      :title (sd-multi-lang-string "Show" :german "Einblenden")
      :push-action
       (progn
         (sd-set-variable-status 'NENN_D :visible t)
         (sd-set-variable-status 'KERN_D_BOLZEN :visible t)
         (sd-set-variable-status 'STEIGUNG :visible t)
         (sd-set-variable-status 'GEW_ART :visible t)
         (sd-set-variable-status 'GEW_UNIT :visible t)
       );;progn
      :toggle-type :grouped-toggle)
   (PUSH-HIDE
      :title (sd-multi-lang-string "Hide" :german "Ausblenden")
      :push-action
       (progn
         (sd-set-variable-status 'NENN_D :visible nil)
         (sd-set-variable-status 'KERN_D_BOLZEN :visible nil)
         (sd-set-variable-status 'STEIGUNG :visible nil)
         (sd-set-variable-status 'GEW_ART :visible nil)
         (sd-set-variable-status 'GEW_UNIT :visible nil)
       );;progn
      :toggle-type :grouped-toggle)
|#
   (NENN_D
     :value-type :length
     :title (sd-multi-lang-string "Nominal D." :german "Nenn D.")
     :initial-visible nil)
     ;:toggle-type :invisible)
   (KERN_D_BOLZEN
     :value-type :length
     :title (sd-multi-lang-string "Core D." :german "Kern D.")
     :initial-visible nil)
     ;:toggle-type :invisible)
   (STEIGUNG
     :value-type :length
     :title (sd-multi-lang-string "Pitch" :german "Steigung")
     :initial-visible nil)
     ;:toggle-type :invisible)
   (GEW_ART  ;; :M :MF ...
     :value-type :keyword
     :title (sd-multi-lang-string "Type" :german "Art")
     :initial-visible nil)
     ;:toggle-type :invisible)
   (GEW_TYPE ;; :OUTER or :INNER
     :value-type :keyword
     :title (sd-multi-lang-string "Thread Type" :german "Gewindeart")
     :initial-visible nil)
     ;:toggle-type :invisible)
   (GEW_UNIT ;; :METRIC or :INCH
     :value-type :keyword
     :title (sd-multi-lang-string "Thread Unit" :german "Gew. Einheit")
     :initial-visible nil)
     ;:toggle-type :invisible)

   (RECHTS_GEW
     :value-type :boolean
     :initial-value t
     :toggle-type :grouped-toggle
     :title (sd-multi-lang-string "Right-Hand" :german "Rechts"))

   (LINKS_GEW
     :value-type :boolean
     :toggle-type :grouped-toggle
     :title (sd-multi-lang-string "Left-Hand" :german "Links"))

   (GEW_L :value-type :length
    :title (sd-multi-lang-string "Length L" :german "Laenge L")
    :prompt-text (sd-multi-lang-string "Specify Length L" :german "Laenge L angeben."))

   (DUMMY_TITLE_1 :title (sd-multi-lang-string "Relief Groove Type" :german "Freistich Form"))
   (FORM_A
     :value-type :boolean
     :initial-value t
     :toggle-type :grouped-toggle
     :size :third
     :title "A")
   (FORM_B  :value-type :boolean
     :toggle-type :grouped-toggle
     :size :third
     :title "B")
   (FREIST_N  :value-type :boolean
     :toggle-type :grouped-toggle
     :size :third
     :title (sd-multi-lang-string "w/o" :german "ohne"))
   (BILD
     :value-type :image
;     :image-file (format nil "~a/LISP/gdm_m1_gewindebolzen.bmp" (oli::sd-convert-filename-from-platform (oli::sd-sys-getenv "SDCORPCUSTOMIZEDIR"))))
     :image-file "C:/ ... PFAD ANPASSEN ... /gdm_m1_gewindebolzen.bmp")

   (DUMMY_TITLE_3 :title (sd-multi-lang-string "Catch" :german "Fangen"))
   (PKT_3D
     :value-type :boolean
     :toggle-type :wide-toggle
     :initial-value t
     :after-input
      (progn  (sd-set-variable-status 'KANTE :enable t)
        (sd-set-variable-status 'PUNKT :enable nil)
        (sd-set-variable-status 'AKT_WP :enable nil)
        (setf PUNKT nil)
      );;progn
     :title (sd-multi-lang-string "3D-Circle Center" :german "Zylinderkante Mitte"))

   (KANTE
     :value-type :edge
     :title (sd-multi-lang-string "Cyl.-Edge" :german "Zyl.-Kante")
     :check-function Eingabe_kante_pruefen
     :after-input
      (progn
        (sd-end-feedback ACHSEN-FEEDBACK)
        (Kantenproperties)
        ;(sd-set-variable-status 'UMKEHREN :enable t)
      );;progn
     :prompt-text (sd-multi-lang-string "Select Cyl.-Edge" :german "Zylinderkante waehlen"))

   (PKT_2D
     :value-type :boolean
     :toggle-type :wide-toggle
     :next-variable (if PKT_2D 'PUNKT)
     :after-input
      (progn  (sd-set-variable-status 'PUNKT :enable t)
        (sd-set-variable-status 'KANTE :enable nil)
        (sd-set-variable-status 'AKT_WP :enable t)
        ;(sd-set-variable-status 'UMKEHREN :enable nil)
        (sd-end-feedback ACHSEN-FEEDBACK)
        (setf KANTE nil)
      );;progn
     :title (sd-multi-lang-string "2D Point on WP" :german "2D Punkt auf AE"))

   (PUNKT :value-type :point-2d
    :title (sd-multi-lang-string "2D Point" :german "2D Punkt")
    :initial-enable nil
    :after-input (progn
                   (sd-end-feedback ACHSEN-FEEDBACK)
                   (setf PUNKT_3D (sd-vec-xform PUNKT :source-space AKT_WP :dest-space :global))
                   (setf ACHSEN-FEEDBACK (sd-start-direction-feedback :point PUNKT_3D :direction (sd-inq-wp-w-dir AKT_WP) :disc t :color 0,0,1))
                 );;progn
    :prompt-text "2D-Punkt waehlen")
#|
   (UMKEHREN
     :title (sd-multi-lang-string "Reverse" :german "Umkehren")
     :toggle-type :wide-toggle
     :initial-enable nil
     :push-action (Achsenrichtung-wechseln))
|#
   ("")

   (next
     :toggle-type :wide-toggle
     :push-action (Gewindebolzen-erstellen)
     :next-variable (if PKT_3D 'KANTE 'PUNKT))

  );;variables

  :mutual-exclusion '((FORM_A FORM_B FREIST_N) (RECHTS_GEW LINKS_GEW) (PKT_3D PKT_2D))

  :local-functions
  '(
    (Gewindebolzen-erstellen ()
      (sd-call-cmds
       (progn
        (setf AKT_WP (sd-inq-curr-wp))
          ;;Arbeitsebene erstellen und positionieren
          (if PKT_3D
             (create_workplane :new :name (sd-gen-obj-basename :workplane) :pt_dir :origin K_MITTELPUNKT :normal K_V-RICHTUNG :u_dir F_ACHSEN-R)
             (progn
               (create_workplane :copy :source AKT_WP :name (sd-gen-obj-basename :workplane) :owner "/")
               (slide_wp_origin (sd-inq-curr-wp) PUNKT)
               (position_wp :workplane (sd-inq-curr-wp) :rotate :axis :v :rotation_angle (/ pi -2))
             );;progn
          );;if

          ;;falls vorhanden, Profil und H-Geo loeschen
          (sd-call-cmds (delete_2d :current_wp :edge_2d :all_2d) :failure nil)

          ;;Profil erstellen
          (geometry_mode :real)
          (let (FA P1 P2 P3 P4)
            (setf FA (/ (- NENN_D (* 0.85 NENN_D)) 2))
            (setf P1 (make-gpnt2d :x GEW_L :y 0))
            (setf P2 (make-gpnt2d :x GEW_L :y (- (/ NENN_D 2) FA)))
            (setf P3 (make-gpnt2d :x (- GEW_L FA) :y (/ NENN_D 2)))
            (setf P4 (make-gpnt2d :x 0 :y (/ NENN_D 2)))
            (polygon 0,0 P1 P2 P3 P4 0,0)
          );;let

          ;;Temporaeres Teil erstellen
          (create_part :name (sd-gen-obj-basename :part) :owner "/")

          ;;Drehen
          (sd-call-cmds (turn :sel_part (sd-inq-curr-part) :wp (sd-inq-curr-wp) :axis :u :rotation_angle (* 2 pi) :keep_wp :yes :keep_profile :no))

          ;;Zylinderflaeche bestimmen
          (setf FLAECHE (first (sd-call-cmds (get_selection :focus_type *sd-cylinder-seltype* :select :in_part (sd-inq-curr-part))))
                ALLES (sd-inq-geo-props FLAECHE :dest-space :global)
                RADIUS (sd-cylinder-radius ALLES)
                RICHTUNG (sd-cylinder-axis-dir ALLES))

          (sd-define-thread FLAECHE
              :nominal-diameter NENN_D
              :core-diameter KERN_D_BOLZEN
              :pitch STEIGUNG
              :thread-type :OUTER
              :thread-unit GEW_UNIT
              :thread-color (sd-color-to-rgb 16753049)
              :thread-hand (if RECHTS_GEW :RIGHT-HAND :LEFT-HAND)
              :thread-profile GEW_ART
              :include-chamfer T
              :thread-direction RICHTUNG
              :thread-name GEW_NAME
          );;sd-define-thread

          ;;Beschriften
          (Cocreate_3d_note :action :create :items FLAECHE :note (if RECHTS_GEW (format nil "~a" GEW_NAME) (format nil "~a-LH" GEW_NAME)))

          ;; Gewindefreistich
          (if (not FREIST_N)
           (progn
            ;;Werte fuer metrischen Gewindefreistich zuordnen
            (let (R DG_W G1_A G1_B DG2 TAN_60 A B P1 P2 P3 P4 P5 WERT)
             (setf WERT 1)
             (case STEIGUNG
               (0.2  (setf  R 0.1  DG_W 0.3  G1_A 0.5  G1_B 0.3))
               (0.25 (setf  R 0.1  DG_W 0.4  G1_A 0.6  G1_B 0.3));;M1
               (0.3  (setf  R 0.2  DG_W 0.5  G1_A 0.6  G1_B 0.3))
               (0.35 (setf  R 0.2  DG_W 0.6  G1_A 0.7  G1_B 0.4));;M1,6
               (0.4  (setf  R 0.2  DG_W 0.7  G1_A 0.8  G1_B 0.5));;M2
               (0.45 (setf  R 0.2  DG_W 0.7  G1_A 1.0  G1_B 0.5));;M2,5
               (0.5  (setf  R 0.2  DG_W 0.8  G1_A 1.1  G1_B 0.5));;M3
               (0.6  (setf  R 0.4  DG_W 1.0  G1_A 1.2  G1_B 0.6))
               (0.7  (setf  R 0.4  DG_W 1.1  G1_A 1.5  G1_B 0.8));;M4
               (0.75 (setf  R 0.4  DG_W 1.2  G1_A 1.6  G1_B 0.9))
               (0.8  (setf  R 0.4  DG_W 1.3  G1_A 1.7  G1_B 0.9));;M5
               (1.0  (setf  R 0.6  DG_W 1.6  G1_A 2.1  G1_B 1.1));;M6
               (1.25 (setf  R 0.6  DG_W 2.0  G1_A 2.7  G1_B 1.5));;M8
               (1.5  (setf  R 0.8  DG_W 2.3  G1_A 3.2  G1_B 1.8));;M10
               (1.75 (setf  R 1.0  DG_W 2.6  G1_A 3.9  G1_B 2.1));;M12
               (2.0  (setf  R 1.0  DG_W 3.0  G1_A 4.5  G1_B 2.5));;M16
               (2.5  (setf  R 1.2  DG_W 3.6  G1_A 5.6  G1_B 3.2));;M20
               (3.0  (setf  R 1.6  DG_W 4.4  G1_A 6.7  G1_B 3.7));;M24
               (3.5  (setf  R 1.6  DG_W 5.0  G1_A 7.7  G1_B 4.7));;M30
               (4.0  (setf  R 2.0  DG_W 5.7  G1_A 9.0  G1_B 5.0));;M36
               (4.5  (setf  R 2.0  DG_W 6.4  G1_A 11.0 G1_B 5.5));;M42
               (5.0  (setf  R 2.5  DG_W 7.0  G1_A 12.0 G1_B 6.5));;M48
               (5.5  (setf  R 3.2  DG_W 7.7  G1_A 13.0 G1_B 7.5));;M56
               (6.0  (setf  R 3.2  DG_W 8.3  G1_A 14.0 G1_B 8.0));;M64
               (otherwise (setf WERT 0))
             );;case
             (if (= WERT 1)
                 (progn
                   (setf DG2 (/ (- NENN_D DG_W) 2))
                   (setf TAN_60 (tan (sd-deg-to-rad 60)))
                   (setf A (/ (- RADIUS DG2) 2))
                   (setf B (* TAN_60 A))
                   (if FORM_A
                      (setf G1 G1_A)
                      (setf G1 G1_B)
                   );;if
                   (setf P1 (make-gpnt2d :x 0 :y DG2)
                         P2 (make-gpnt2d :x G1 :y DG2)
                         P3 (make-gpnt2d :x (+ G1 B) :y RADIUS)
                         P4 (make-gpnt2d :x (+ G1 B) :y (+ RADIUS 1))
                         P5 (make-gpnt2d :x 0 :y (+ RADIUS 1))
                   );;setf
                   ;;Profil fuer Gewindefreistich erstellen
                   (geometry_mode :real)
                   (polygon P1 P2 P3 P4 P5 :close)
                   (fillet :create :fillet_radius R P1 P2)
                   ;;Gewindefreistich erstellen
                   (sd-call-cmds (bore :parts (sd-inq-curr-part) :keep_wp :no :axis :u :rotation_angle (* 2 pi)))
                 );;progn
                 (display (sd-multi-lang-string "Missing Value for pitch > Relief Groove could not be created!" 
                                        :german "Fehlende Werte fuer die Gewindesteigung > Freistich konnte nicht erstellt werden!"))
            );;if
            );;let
           );;progn
           (delete_3d (sd-inq-curr-wp))
          );;if (not FREIST_N)  === Ende Gewindefreistich ===

          ;;Mit TEIL verschmelzen
          (sd-call-cmds (unite_3d :blank TEIL :tools (sd-inq-curr-part) :keep_tools :no))

          ;;Urspungs AE aktiv setzen
          (current_wp AKT_WP)

          ;;Ursprungsteil aktiv setzen
          (current_part TEIL)

          ;;Feedback loeschen
          (sd-end-feedback ACHSEN-FEEDBACK)
       );;progn
      );;sd-call-cmds
    );;Gewindebolzen-erstellen


    ;;=====================================
    ;; Eingabe auf Geo (Kreiskante) pruefen
    (Eingabe_kante_pruefen (WERT)
     (let (F_PLANE) 
      (if (sd-circle-p (sd-inq-geo-props WERT :dest-space :global))
          (progn
           (setf F_PLANE nil)
           (sd-call-cmds (get_selection :focus_type *sd-plane-seltype* :select :by_edge_3d WERT)
                                        :failure (setf F_PLANE nil)
                                        :success (setf F_PLANE *SD-ACTION-RESULT*))
           (if F_PLANE
               :ok
               (values :error (sd-multi-lang-string "Selected 3D-Edge is not owner of plane surface!" :german "Die gewaehlte 3D-Kreiskante besitzt keine ebene Flaeche!"))
           );;if
          );;progn
          (values :error (sd-multi-lang-string "Selected Element is not of type 3D-Edge!" :german "Das gewaehlte Element ist keine 3D-Kreiskante!"))
      );;if
     );;let
    );;Eingabe_kante_pruefen


    ;;=====================================
    (Achsenrichtung-wechseln ()
      (sd-end-feedback ACHSEN-FEEDBACK)
      (setf F_ACHSEN-R (make-gpnt3d :x (* -1 (gpnt3d_x F_ACHSEN-R)) :y (* -1 (gpnt3d_y F_ACHSEN-R)) :z (* -1 (gpnt3d_z F_ACHSEN-R))))
      (setf ACHSEN-FEEDBACK (sd-start-direction-feedback :point K_MITTELPUNKT :direction F_ACHSEN-R :disc t :color 0,0,1))
    );;Achsenrichtung-wechseln


    ;;=====================================
    (Kantenproperties ()
     (let (F_ALLES P_FLAECHE) 
      (setf P_FLAECHE nil
            K_ALLES (sd-inq-geo-props KANTE :dest-space :global)
            K_MITTELPUNKT (sd-circle-center K_ALLES)
            K_RADIUS  (sd-circle-radius K_ALLES)
            K_V-RICHTUNG  (sd-circle-start-dir K_ALLES)
            K_ACHSEN-R  (sd-circle-normal K_ALLES)
            K_DURCHMESSER (* K_RADIUS 2)
      );setf
      (sd-call-cmds (get_selection :focus_type *sd-plane-seltype*
                                   :select :by_edge_3d KANTE)
                                   :failure (display "nichts gefunden")
                                   :success (setf P_FLAECHE *SD-ACTION-RESULT*))
      (sd-call-cmds (setf F_ACHSEN-R (sd-plane-normal (sd-inq-geo-props (first P_FLAECHE) :dest-space :global))))
      (setf ACHSEN-FEEDBACK (sd-start-direction-feedback :point K_MITTELPUNKT :direction F_ACHSEN-R :disc t :color 0,0,1))
     );;let
    );;Kantenproperties

  );;local-function

  :cancel-action '(sd-end-feedback ACHSEN-FEEDBACK)

  :ok-action '(Gewindebolzen-erstellen)

);;sd-defdialog

;;=== EOF
